/*

simple example of drawing random 3d spheres

*/

const JSUI_BOULES_VERSION = 1.0;

var sketch_edit = new Sketch();
//var sketch_run = new Sketch();

sketch_edit.size = sketch.size;
var aspect = sketch.size[0]/sketch.size[1];
var width = sketch.size[0];
var height = sketch.size[1];

sketch_conf(sketch);

var helper_str="";
var helper_upd=0;
var textX = 0.01;
var textY = 0.9;

var var_h,var_i,var_1,var_2 ,var_3,var_r,var_g,var_b;

var flag_upd=1;
var flag_draw=1;


var draw_task = new Task(draw,this,null);

var def_size = 0.4;
var def_shape = 1;
var pt_size = 0.04;
var draw_zoom=1.;

var boule_drag, source_drag;
var soff = 32;
var start_sx, start_sy;
var start_wx, start_wy;

var refx,refy;

var drag_mode;

var tmp_num;
var boules_array = new Array();
var sources_array = new Array();

sources_array[0] = new source_o(1,0.,0.,0.); 

sources_color = new Array([255,0,0,255]
						,[0,0,255,255]
						,[0,255,0,255]
						,[124,124,0,255]
						,[124,85,85,255]
						,[255,200,0,255]
						,[0,124,124,255]
						,[255,0,255,255]
						,[50,124,8,255]
						,[60,120,8,255]
						,[70,111,8,255]
						,[80,100,8,255]
						,[90,90,8,255]
						,[99,80,8,255]
						,[120,60,8,255]
						,[150,40,8,255]);

boules_color = new Array([255,0,0,255]
						,[0,0,255,255]
						,[0,255,0,255]
						,[124,124,0,255]
						,[124,85,85,255]
						,[255,200,0,255]
						,[0,124,124,255]
						,[255,0,255,255]
						,[50,124,8,255]
						,[60,120,8,255]
						,[70,111,8,255]
						,[80,100,8,255]
						,[90,90,8,255]
						,[99,80,8,255]
						,[120,60,8,255]
						,[150,40,8,255]);
var alpha_boule = 0.25;

clear_color = [1.,1.,1.,1.];
clear_color_vmode = [0.9,0.9,0.9,0.9];

for(var i = 0 ; i < sources_color.length ; i++)
{
	sources_color[i][0] = sources_color[i][0]/255.;
	sources_color[i][1] = sources_color[i][1]/255.;
	sources_color[i][2] = sources_color[i][2]/255.;
	sources_color[i][3] = sources_color[i][3]/255.;
}

for(var i = 0 ; i < boules_color.length ; i++)
{
	boules_color[i][0] = boules_color[i][0]/300.;
	boules_color[i][1] = boules_color[i][1]/300.;
	boules_color[i][2] = boules_color[i][2]/300.;
	boules_color[i][3] = alpha_boule;
}

var draw_shape_b = 1;
shape_stringi = new Array("G","L","E","E2","S");
shape_string = new Array("Gaussian","Linear","Exponential","Exponential2","Threshold");

vslices=40;
vmode = 0;

/*******   TEMP*
pos_buffer = new Array();
for(var i = 0; i< 16; i++)
{
	pos_buffer[i]=new Array();
}

********/


//this.sketch = sketch_edit;

draw_task.interval = 100;

draw_task.repeat();

function draw_interval(d)
{
	draw_task.interval = d;
}

//***************************
// 			DRAW
//****************************

function sketch_conf(sketch)
{
	
	with (sketch) { 
	
	glpolygonmode("front_and_back","fill"); 
	glpointsize(1.); 
	gllinewidth(1.); 
	glenable("depth_test"); 
	gldisable("fog"); 
	glcolor(0.,0.,0.,1.); 
	glshademodel("smooth"); 
	gldisable("lighting"); 
	gldisable("normalize"); 
	gldisable("texture"); 
	glmatrixmode("projection"); 
	glloadidentity(); 
	glortho(-draw_zoom*aspect, draw_zoom*aspect, -draw_zoom, draw_zoom, -1,100.); 
	glmatrixmode("modelview"); 
	glloadidentity(); 
	glulookat(0.,0.,2.,0.,0.,0.,0.,0.,1.); 
	glclearcolor(1., 1., 1., 1.); 
	glclear(); 
	//glenable("depth_test"); 
	glenable("blend"); 
	glblendfunc("src_alpha","one_minus_src_alpha"); 
	
	fsaa = 0;
	//glenable("depth_test"); 
}
}

function post_redraw()
{
	flag_draw = 1;
}

function draw()
{
	if(flag_draw)
	{
		with(sketch){
		
		if( !vmode )
		{
			glclearcolor(clear_color);
			glclear();
			draw_boules(sketch);
		}
		else
		{
			glclearcolor(clear_color_vmode);
			glclear();
			if(flag_upd)
			{
				draw_boules(sketch);
				sketch_edit.copypixels(sketch,0,0);
				flag_upd = 0;
			}
			sketch.copypixels(sketch_edit,0,0);
		}
		draw_helper(sketch);
		draw_sources(sketch);
		
		}
		
		refresh();
		flag_draw = 0;
	}
	
}

function draw_boules(sketchin)
{
	//sketchin.glclearcolor(clear_color);
	//sketchin.glclear();
	for (var i = 0; i < boules_array.length; i++) {
		// update Z:
		boules_array[i].z = (-i+2);
		boules_array[i].num = i+1;
		boules_array[i].color[3] = alpha_boule;
		boules_array[i].draw(sketchin);
	
	}
}

function draw_sources(sketchin)
{
	for (var i = 0; i < sources_array.length; i++) {
		
		sources_array[i].z = (-i+2-soff);
		sources_array[i].draw(sketchin);
	
	}
}

function bang()
{
	outlet_boule_all();
	outlet_sources_all();
	
	post_redraw();
}

function draw_helper(sketchin)
{
	with(sketchin)
	{
		glcolor(0);
		moveto(-draw_zoom*aspect*0.95,draw_zoom*textY);
		fontsize(10);
		textalign("left","down");
		text(helper_str);
		helper_str="";
		
		moveto(draw_zoom*aspect*0.95,draw_zoom*textY);
		fontsize(10);
		textalign("right","down");
		if(vmode)
			text("source mode");
		else	text("boule mode");
	}
}

//****************************
// 			INTERACT
//****************************


function onclick(x,y,button,mod1,shift,caps,opt,mod2)
{
	//post(x,y,button,mod1,shift,caps,opt,mod2);
	//post();
	var coord;
	
	drag_mode = mod1 + 2 * opt + 4 * shift + 8 * mod2;
	//post("drag_mode : " + drag_mode);
	//post();
	

	coord = sketch.screentoworld(x,y);
	
	start_sx = x;
	start_sy = y;
	
	start_wx = coord[0];
	start_wy = coord[1];
	
	if(drag_mode == 3 ) /// + alt
	{
		edit_mode(!vmode);
		return;
	}
	
	if (vmode)
	{
		//sources_array[0].move(coord[0],coord[1],coord[2]);
		source_drag = Math.floor((0.5 + sketch.depthatpixel(x,y)*100.)) - 1;
				if(source_drag == 99 || source_drag < soff)
					source_drag = -1;
				else
					source_drag = source_drag - soff;
					
		switch (drag_mode)
		{
			case 1 :
				add_source(coord[0],coord[1],0.);
				post_redraw();
				break;
			
			case 4 :
				remove_source(source_drag);
				break;
		
		}
		
		post_redraw();
	}else // si mode edit
	{
	
		boule_drag = Math.floor((0.5 + sketch.depthatpixel(x,y)*100.)) - 1;
				if(boule_drag == 99 || boule_drag > soff)
					boule_drag = -1;
		
		switch (drag_mode)
		{
			case 1 :
				add_boule(coord[0],coord[1],def_size,def_size,def_shape,Math.random());
				post_redraw();
				break;
				
			case 2 :
				if(boule_drag >= 0 && boule_drag < boules_array.length)
				{
				refx = boules_array[boule_drag].sizex;
				refy = boules_array[boule_drag].sizey;
				}
				break;
				
			case 4 :
				remove_boule(boule_drag);
				break;
				
			case 6 :  // alt + shift
				if(boule_drag >= 0 && boule_drag < boules_array.length)
				{
				refx = boules_array[boule_drag].sizex;
				refy = boules_array[boule_drag].sizey;
				}
				break;
				
			case 8 :
				if(boule_drag >= 0 && boule_drag < boules_array.length)
				{
				refy = boules_array[boule_drag].shape;
				
				}
				break;
			
				
			default :
				
				
				/*post("found : " + boule_drag + " with " + sketch.depthatpixel(x,y)*100.);
				post(x,y);
				post();*/
		}
	
	}
	//post(coord[0],coord[1],coord[2],def_size,1);
	
	
}

function ondrag(x,y,button,mod1,shift,caps,opt,mod2)
{

	var coord;
	var sx,sy;
	
	coord = sketch.screentoworld(x,y);
	
	if (vmode)
	{
		
		if(source_drag >= 0 && source_drag < sources_array.length && drag_mode == 0)	
		{
			sources_array[source_drag].move(coord[0],coord[1],-1);

			helper_str = "source " + (source_drag+1) + " : pos " +coord[0].toFixed(3)+ "  " + coord[1].toFixed(3);
				
		}
		//sources_array[0].move(coord[0],coord[1],coord[2]);
	}else
	{
		switch ( drag_mode)
		{
			case 0 : // move boule
				if(boule_drag >= 0 && boule_drag < boules_array.length)
				{
				boules_array[boule_drag].move(coord[0],coord[1],-1);
				helper_str = "boule " + (boule_drag+1) + " : pos " +coord[0].toFixed(3)+ "  " + coord[1].toFixed(3);
				//post("move " + boule_drag + " -> " + coord[0],coord[1]);
				//post();
				}
				break;
			
			case 2 : // size boule
				if(boule_drag >= 0 && boule_drag < boules_array.length)
				{
					
					sy = Math.exp((coord[1]-start_wy));
					sx = sy * refx;
					sy = sy * refy;
				boules_array[boule_drag].scale(sx,sy);
				helper_str = "boule " + (boule_drag+1) + " : size " +sx.toFixed(3)+ "  " + sy.toFixed(3);

				//post("size " + boule_drag + " -> " + sx+ " " + sy);
				//post();
				}
				break;
			
			case 6: // size x y boule
				if(boule_drag >= 0 && boule_drag < boules_array.length)
				{
					sx = Math.exp((coord[0]-start_wx))*refx;
					sy = Math.exp((coord[1]-start_wy))*refy;
				boules_array[boule_drag].scale(sx,sy);
				helper_str = "boule " + (boule_drag+1) + " : size " +sx.toFixed(3)+ "  " + sy.toFixed(3);
				//post("size " + boule_drag + " -> " + sx+ " " + sy);
				//post();
				}
				break;
				
			case 8: // boule shape
				if(boule_drag >= 0 && boule_drag < boules_array.length)
				{
					//sx = (coord[0]-start_wx);
					sy = (coord[1]-start_wy);
				sx = refy + sy*10;
				sx = Math.round(Math.max(Math.min(sx,5),1));
				boules_array[boule_drag].shape = sx;
				helper_str = "boule " + (boule_drag+1) + " : shape "+ sx+"-"+shape_string[sx-1]; 
				boules_array[boule_drag].out();
				}
				break;
				
				
		}
	}
	//post(coord[0],coord[1],coord[2],def_size,1);
	
	post_redraw();
}


function onresize(width,height)
{
	sketch.size = [width,height];
	sketch_edit.size = sketch.size;
	
	aspect = sketch.size[0]/sketch.size[1];
	sketch_conf(sketch);
	
	sketch.glmatrixmode("projection"); 
	sketch.glloadidentity(); 
	sketch.glortho(-draw_zoom*aspect, draw_zoom*aspect, -draw_zoom, draw_zoom, -1,100.); 
	
	post_redraw();

}

function clear()
{
	boules_array.length = 0;
	sources_array.length = 0;
	flag_upd=1;
	post_redraw();
}

//****************************
// 			DATA
//****************************

function boule_o(num,x,y,z,sizex,sizey,shape,color)
{
	this.num = num;
	this.x = x;
	this.y = y;
	this.z = z;
	this.colorh = color;
	//this.color = HSV2RGB(color,1.,1.,0.3);
	//post(HSV2RGB(color,0.9,1.,0.3));
	this.color = color;
	this.sizex = sizex;
	this.sizey = sizey;
	this.shape = shape;
	this.draw = draw_boule;
	this.move = move_boule;
	this.scale = scale_boule;
	this.out = outlet_boule;
}

function draw_boule(sketchin)
{
	
	with(Math){
	with (sketchin)
	{
		
		glenable("blend"); 
		glblendfunc("src_alpha","one_minus_src_alpha"); 
		
		moveto(this.x,this.y,-1);
		glcolor(this.color);
		//roundedplane(4.,this.sizex,this.sizey);
		shapeslice(vslices);
		ellipse(this.sizex,this.sizey);
		glenable("depth_test");
		//glcolor(this.color[0],this.color[1],this.color[2]*0.2,0.8);
		glcolor(this.color[0],this.color[1],this.color[2],0.8);
		moveto(this.x,this.y,this.z);
		roundedplane(4.,pt_size,pt_size);
		gldisable("depth_test");
		
		
		var offs = 15./height;
		moveto(this.x + offs,this.y + offs,-1);
		fontsize(12);
		textalign("left","down");
		text(""+this.num);
		
		if(draw_shape_b)
		{
			/*moveto(this.x,this.y,-32);
			glcolor(0);
			fontsize(12);
			textalign("center","center");
			text(shape_stringi[this.shape-1]);*/
			moveto(this.x-offs,this.y-offs,-1);
			
			fontsize(12);
			textalign("right","up");
			text(shape_stringi[this.shape-1]);
		}
		
		
	}
	}
}

function add_boule(x,y,sizex,sizey,shape,color) // in world coord
{
	with(Math)
	boules_array[boules_array.length] = new boule_o(boules_array.length+1,x,y,(-boules_array.length+2),sizex,sizey,shape,boules_color[(boules_array.length)%16]);
	
	outlet_boule_all();
}

function add_boule_num(num,x,y,sizex,sizey,shape)
{
	add_def_boules_until(num);
	num = num-1;
	if(num >= 0)
	with(Math)
	boules_array[num] = new boule_o(num,x,y,-1,sizex,sizey,shape,boules_color[num%16]);
	
	outlet_boule_all();
}

function add_def_boules_until(num)
{
	while(boules_array.length < num)
	{
		add_boule(Math.random()*2-1,Math.random()*2-1,def_size,def_size,def_shape,-1);
	}
}

function move_boule(x,y,z)
{
	this.x = x;
	this.y = y;
	//this.z = z;
	
	this.out();
	
	
}

function scale_boule(x,y)
{
	this.sizex = x;
	this.sizey = y;
	//this.z = z;
	
	this.out();
}

function outlet_boule()
{
	outlet(0,"boule",this.num,this.x,this.y,this.sizex,this.sizey,this.shape);
	notifyclients();
}

function outlet_boule_all()
{
	outlet(0,"boule",-1);
	for (var i = 0; i < boules_array.length; i++) {
		
		boules_array[i].out();
	
	}
	notifyclients();
}

function remove_boule(num)
{
	if(num<boules_array.length)
		boules_array.splice(num, 1);
	
	boule_update_num();
	outlet_boule_all();
	
}

function boule_update_num()
{
	
	for (var i = 0; i < boules_array.length; i++) {

		boules_array[i].num = i+1;
	}
}

///***************
// SOURCES
//*****************


function source_o(num,x,y,z)
{
	this.num = num;
	this.x = x;
	this.y = y;
	this.z = z;
	this.draw = draw_source;
	this.move = move_source;
	this.out = outlet_source;
	
	this.pos_buffer = new Array();
}
source_o.local = 1;

function draw_source(sketchin)
{
	var pos_tmp;
	
	with(Math){
	with (sketchin)
	{
		moveto(this.x,this.y,this.z);
		glcolor(sources_color[this.num-1]);
		
		/*cube(0.08,0.005,0.03);
		cube(0.005,0.08,0.03);
		circle(0.05);*/
		glenable("depth_test");
		shapeorient(0.,0.,45.);
		cube(0.05,0.05,0.03);
		shapeorient(0.,0.,0.);
		gldisable("depth_test");
		
		/***/
		while(this.pos_buffer.length)
		{
			gllinewidth(3);
			pos_tmp = this.pos_buffer.pop();
			lineto(pos_tmp[0],pos_tmp[1]);
			
		}
		moveto(this.x,this.y,this.z);
		/***/
		
		fontsize(12);
		//moveto(this.x-0.02,this.y-0.02,-1);
		textalign("center","center");
		
		glcolor(0.,0.,0.,1);
		text(""+this.num);
		
		
		
	}
	}
}

function move_source(x,y,z)
{
	this.x = x;
	this.y = y;
	this.z = z;
	
	this.out();
	
	this.pos_buffer.push([x,y]);
}

function source_move(num,x,y)
{
	tmp_num = num-1;
	if( tmp_num >= 0 && tmp_num < sources_array.length )
	{
	sources_array[tmp_num].x = x;
	sources_array[tmp_num].y = y;
	
	sources_array[tmp_num].pos_buffer.push([x,y]);
	}
	
	post_redraw();
}

function add_source(x,y,z) // in world coord
{
	sources_array[sources_array.length] = new source_o(sources_array.length+1,x,y,z);
	
	sources_array[sources_array.length-1].out();
}

function add_source_num(num,x,y)
{
	add_def_sources_until(num);
	num = num-1;
	if(num >= 0)
	{
		sources_array[num].x = x;
		sources_array[num].y = y;
	}

	outlet_sources_all();
}

function add_def_sources_until(num)
{
	while(sources_array.length < num)
	{
		add_source(Math.random(),Math.random(),-1);
	}
}

function remove_source(num)
{
	if(num<sources_array.length)
		sources_array.splice(num, 1);
	
	source_update_num();
	outlet_sources_all();
	
}

function outlet_source()
{
	outlet(0,"source",this.num,this.x,this.y,this.z);
	notifyclients();
}

function outlet_sources_all()
{
	for (var i = 0; i < sources_array.length; i++) {
		
		sources_array[i].out();
	
	}
	//notifyclients();
	
}

function source_update_num()
{
	
	for (var i = 0; i < sources_array.length; i++) {

		sources_array[i].num = i+1;
	}
}

//$$$$$$$$$$$$$$$$$$$$$$$$$$$$
//      Exposed SOURCES
//$$$$$$$$$$$$$$$$$$$$$$$$$$$$

function source(num,x,y)
{
	switch(arguments.length)
	{
		case 2 :
			add_source(num,x,-1);
			break;
		case 3 :
			add_source_num(num,x,y);
			break;

		default :
			error("source needs at least 2 args <x> <y>");
			break;

	}

	post_redraw();
}

function source_pos(num,x,y)
{
	switch(arguments.length)
	{
		case 3 :
			
			add_def_sources_until(num);
			sources_array[num-1].x = x;
			sources_array[num-1].y = y;
			sources_array[num-1].pos_buffer.push([x,y]);
			break;
		default :
			error("source_pos needs 3 args <num> <x> <y>");
		
	}
	outlet_sources_all();
	post_redraw();
}

function source_clear(num)
{
	
	switch(arguments.length)
	{
		case 0:
			sources_array.length = 0;
			post("clearing all sources");post();
			break;
		case 1:
			remove_source(num-1);
			break;
		default :
			error("source_clear");
		
	}
	outlet_sources_all();
	post_redraw();
}


//$$$$$$$$$$$$$$$$$$$$$$$$$$$$
//      Exposed BOULES
//$$$$$$$$$$$$$$$$$$$$$$$$$$$$

function boule(num,x,y,sizex,sizey,shape)
{
	switch(arguments.length)
	{
		case 2 :
			add_boule(num,x,def_size,def_size,def_shape,-1);
			break;
		case 3 :
			add_boule_num(num,x,y,def_size,def_size,def_shape);
			break;
		case 4 :
			add_boule_num(num,x,y,sizex,sizex,def_shape);
			break;
		case 5 :
			add_boule_num(num,x,y,sizex,sizey,def_shape);
			break;
		case 1 :
			error("boule needs at least 2 args <x> <y>");
			break;
		default :
			add_boule_num(num,x,y,sizex,sizey,shape);
			break;
	}
	flag_upd=1;
	post_redraw();
}

function boule_pos(num,x,y)
{
	switch(arguments.length)
	{
		case 3 :
			add_def_boules_until(num);
			boules_array[num-1].x = x;
			boules_array[num-1].y = y;
			break;
		default :
			error("boule_pos needs 3 args <num> <x> <y>");
		
	}
	outlet_boule_all();
	flag_upd=1;
	post_redraw();
}

function boule_size(num,sizex,sizey)
{
	switch(arguments.length)
	{
		case 2:
			add_def_boules_until(num);
			boules_array[num-1].sizex = sizex;
			boules_array[num-1].sizey = sizex;
			break;
		case 3 :
			add_def_boules_until(num);
			boules_array[num-1].sizex = sizex;
			boules_array[num-1].sizey = sizey;
			break;
		default :
			error("boule_size needs at least 2 args <num> <sizex> [<sizey>]");
		
	}
	outlet_boule_all();
	flag_upd=1;
	post_redraw();
}

function boule_size_all(sizex,sizey)
{
	switch(arguments.length)
	{
		case 1:
			for(var i=0; i< boules_array.length ; i++)
				boules_array[i].sizex  = boules_array[i].sizey = sizex;
			break;
		case 2:
			for(var i=0; i< boules_array.length ; i++){
				boules_array[i].sizex = sizex;
				boules_array[i].sizey = sizey;}
			break;
		default :
			error("boule_size_all needs 2 args <sizex> <sizey>");
		
	}
	outlet_boule_all();
	flag_upd=1;
	post_redraw();
}

function boule_weight(num,weight)
{
	var xyratio,sx,sy;
	if(weight > 0.){
	switch(arguments.length)
	{
		case 2:
			add_def_boules_until(num);
			sx = boules_array[num-1].sizex;
			sy = boules_array[num-1].sizey;
			xyratio = Math.abs(sx) + Math.abs(sy);
			weight = 2.*weight/xyratio;
			boules_array[num-1].sizex = sx * weight;
			boules_array[num-1].sizey = sy * weight;
			break;
		default :
			error("boule_weight needs 2 args <num> <weight>");
		
	}
	outlet_boule_all();
	flag_upd=1;
	post_redraw();
	}
}

function boule_weight_all(weight)
{
	var xyratio,sx,sy,w;
	if(weight > 0.){
	switch(arguments.length)
	{
		case 1:
			for(var i=0; i< boules_array.length ; i++)
			{
				sx = boules_array[i].sizex;
				sy = boules_array[i].sizey;
				xyratio = Math.abs(sx) + Math.abs(sy);
				w = 2.*weight/xyratio;
				boules_array[i].sizex = sx * w;
				boules_array[i].sizey = sy * w;
			}
			break;
		default :
			error("boule_weight_all needs 1 args <weight>");
		
	}
	outlet_boule_all();
	flag_upd=1;
	post_redraw();
	}
}

function boule_shape(num,shape)
{
	switch(arguments.length)
	{
		case 2:
			add_def_boules_until(num);
			boules_array[num-1].shape = Math.round(Math.max(Math.min(shape,5),1));
			break;
		default :
			error("boule_shape needs 2 args <num> <shape>");
		
	}
	outlet_boule_all();
	flag_upd=1;
	post_redraw();
}

function boule_shape_all(shape)
{
	shape = Math.round(Math.max(Math.min(shape,5),1));
	switch(arguments.length)
	{
		case 1:
			for(var i=0; i< boules_array.length ; i++)
				boules_array[i].shape  = shape;
			break;
		default :
			error("boule_shape_all needs 1 arg <shape>");
		
	}
	outlet_boule_all();
	flag_upd=1;
	post_redraw();
}

function boule_clear(num)
{
	
	switch(arguments.length)
	{
		case 0:
			boules_array.length = 0;
			post("clearing all boules");post();
			break;
		case 1:
			remove_boule(num-1);
			break;
		default :
			error("boule_clear");
		
	}
	outlet_boule_all();
	flag_upd=1;
	post_redraw();
}

function boule_alpha(alpha)
{
	alpha_boule = Math.min(Math.max(alpha,0.),1);
	flag_upd=1;
	post_redraw();
}

//****************************
// 			CONF
//****************************

function zoom(z)
{
	draw_zoom = z;
	with(sketch)
	{
		glmatrixmode("projection"); 
		glloadidentity(); 
		glortho(-z*aspect, z*aspect, -z, z, -1,100.); 

	}
	
	flag_upd = 1;
	post_redraw();
}

function fsaa(v)
{
	sketch.fsaa = v;
	refresh();
}

function polymode(f,b)
{
	sketch.glpolygonmode("front",f);
	sketch.glpolygonmode("back",b);
}

function ortho(v)
{
	if (v) {
		sketch.glmatrixmode("projection");
		sketch.glortho(-1,1,-1,1,0.01,1000.);
	}
	flag_upd = 1;
	post_redraw();
}

function edit_mode(v)
{
	vmode = v;
	//sketch_edit.copypixels(sketch,0,0);
	flag_upd = v;
	post_redraw();

}

function slices(v)
{
	vslices = v;
	
}

function isize()
{
	post(this.sketch.size);
	post();
	post(sketch_edit.size);
	post();
	
}

function error(str)
{
	post(" error jsui_boules : " + str);
	post();
}
//****************************
// 			PATTR
//****************************

function getvalueof()
{
 	
 	var i;
	var data = new Array();
	var dataIdx = 0;
	
	data[dataIdx++] = JSUI_BOULES_VERSION;
	//data[dataIdx++] = vslices;
	//data[dataIdx++] = vmode;
	
	for(i=0;i<boules_array.length;i++)
	{
		data[dataIdx++] = "boules"
		data[dataIdx++] = boules_array[i].num;
		data[dataIdx++] = boules_array[i].x;
		data[dataIdx++] = boules_array[i].y;
		data[dataIdx++] = boules_array[i].z;
		data[dataIdx++] = boules_array[i].sizex;
		data[dataIdx++] = boules_array[i].sizey;
		data[dataIdx++] = boules_array[i].shape;
		data[dataIdx++] = boules_array[i].colorh;
	}
	
	
	for(i=0;i<sources_array.length;i++)
	{
		data[dataIdx++] = "sources"
		data[dataIdx++] = i+1;
		data[dataIdx++] = sources_array[i].x;
		data[dataIdx++] = sources_array[i].y;
		data[dataIdx++] = sources_array[i].z;

	}
	
	return data;
	
}

function setvalueof()
{
	var i = 0;
	var num,x,y,z,sizex,sizey,shape,color;
	var argIdx = 0;
	var Version = arguments[argIdx++];
	
	boules_array.length = 0;
	sources_array.length = 0;
	
	if(Version == 1.0)
	{
		//vslices = arguments[argIdx++];
		//vmode = arguments[argIdx++];
		
		while(arguments[argIdx] == "boules")
		{
			argIdx++;
			num = arguments[argIdx++];
			x = arguments[argIdx++];
			y = arguments[argIdx++];
			z = arguments[argIdx++];
			sizex = arguments[argIdx++];
			sizey = arguments[argIdx++];
			shape = arguments[argIdx++];
			color = arguments[argIdx++];
			
			add_boule(x,y,sizex,sizey,shape,color);
			
			//boules_array[boules_array.length - 1].color = color;
		}
		
		while(arguments[argIdx] == "sources")
		{
			argIdx++;
			num = arguments[argIdx++];
			x = arguments[argIdx++];
			y = arguments[argIdx++];
			z = arguments[argIdx++];
			
			add_source(x,y,z);
		}
	}
	
	flag_upd = 1;
	post_redraw();
	
}

//****************************
// 			CONF
//****************************

function HSV2RGB (h,s,v,a) {
	var RGB = new Array();
	if (s == 0) {
		RGB[0] = v ;
		RGB[1] = v ;
		RGB[2] = v ;
		RGB[3] = a ;
	} else {
		var_h = h * 6;
		var_i = Math.floor(var_h);
		var_1 = v * (1 - s);
		var_2 = v * (1 - s * (var_h - var_i));
		var_3 = v * (1 - s * (1 - (var_h - var_i)));
		
		if (var_i == 0) {var_r = v; var_g = var_3; var_b = var_1}
		else if (var_i == 1) {var_r = var_2; var_g = v; var_b = var_1}
		else if (var_i == 2) {var_r = var_1; var_g = v; var_b = var_3}
		else if (var_i == 3) {var_r = var_1; var_g = var_2; var_b = v}
		else if (var_i == 4) {var_r = var_3; var_g = var_1; var_b = v}
		else {var_r = v; var_g = var_1; var_b = var_2};
		
		RGB[0] = var_r ;
		RGB[1] = var_g ;
		RGB[2] = var_b ;
		RGB[3] = a ;
	}
	
	return RGB;
}